module kelog;
import lexer;
import parser;
import runtime;

import std.file;
import std.stdio;

void main( string[] argv )
{
	if( argv.length == 1 )
	{
		writeln("Welcome to <Kinaba's Ese proLOG> v0.02:");
		writeln("  ", argv[0], " [filename.pl]");
		return;
	}

	auto src  = cast(string) std.file.read(argv[1]);
	auto lex  = new Lexer(src);
	auto par  = new Parser(lex);
	auto prog = par.parse_program();
	auto rt   = new Runtime(prog);

	for(int i=0; i<rt.length; ++i)
		rt.run_query(i);
}
